Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp	(revision 128)
@@ -47,4 +47,81 @@
   sc_clock              *  in_CLOCK  = new sc_clock ("clock", 1.0, 0.5);	 
   sc_signal<Tcontrol_t> *  in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
+
+  sc_signal<Tcontrol_t           >  ** out_ICACHE_REQ_VAL                 ;
+  sc_signal<Tcontrol_t           >  **  in_ICACHE_REQ_ACK                 ;
+//sc_signal<Tcontext_t           >  ** out_ICACHE_REQ_THREAD_ID           ;
+  sc_signal<Tpacket_t            >  ** out_ICACHE_REQ_PACKET_ID           ;
+  sc_signal<Ticache_instruction_t>  ** out_ICACHE_REQ_ADDRESS             ;
+  sc_signal<Ticache_type_t       >  ** out_ICACHE_REQ_TYPE                ;
+  sc_signal<Tcontrol_t           >  **  in_ICACHE_RSP_VAL                 ;
+  sc_signal<Tcontrol_t           >  ** out_ICACHE_RSP_ACK                 ;
+//sc_signal<Tcontext_t           >  **  in_ICACHE_RSP_THREAD_ID           ;
+  sc_signal<Tpacket_t            >  **  in_ICACHE_RSP_PACKET_ID           ;
+  sc_signal<Ticache_instruction_t> ***  in_ICACHE_RSP_INSTRUCTION         ;
+  sc_signal<Ticache_error_t      >  **  in_ICACHE_RSP_ERROR               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_VAL                      ;
+  sc_signal<Tcontrol_t           >  **  in_DECOD_ACK                      ;
+  sc_signal<Tcontext_t           >  ** out_DECOD_CONTEXT_ID               ;
+  sc_signal<Tdepth_t             >  ** out_DECOD_DEPTH                    ;
+  sc_signal<Ttype_t              >  ** out_DECOD_TYPE                     ;
+  sc_signal<Toperation_t         >  ** out_DECOD_OPERATION                ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_NO_EXECUTE               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_IS_DELAY_SLOT            ;
+  sc_signal<Tgeneral_data_t      >  ** out_DECOD_ADDRESS                  ;
+  sc_signal<Tgeneral_data_t      >  ** out_DECOD_ADDRESS_NEXT             ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_HAS_IMMEDIAT             ;
+  sc_signal<Tgeneral_data_t      >  ** out_DECOD_IMMEDIAT                 ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_READ_RA                  ;
+  sc_signal<Tgeneral_address_t   >  ** out_DECOD_NUM_REG_RA               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_READ_RB                  ;
+  sc_signal<Tgeneral_address_t   >  ** out_DECOD_NUM_REG_RB               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_READ_RC                  ;
+  sc_signal<Tspecial_address_t   >  ** out_DECOD_NUM_REG_RC               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_WRITE_RD                 ;
+  sc_signal<Tgeneral_address_t   >  ** out_DECOD_NUM_REG_RD               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_WRITE_RE                 ;
+  sc_signal<Tspecial_address_t   >  ** out_DECOD_NUM_REG_RE               ;
+  sc_signal<Texception_t         >  ** out_DECOD_EXCEPTION_USE            ;
+  sc_signal<Texception_t         >  ** out_DECOD_EXCEPTION                ;
+  sc_signal<Tcontrol_t           >  **  in_BRANCH_COMPLETE_VAL            ;
+  sc_signal<Tcontrol_t           >  ** out_BRANCH_COMPLETE_ACK            ;
+  sc_signal<Tcontext_t           >  **  in_BRANCH_COMPLETE_CONTEXT_ID     ;
+  sc_signal<Tdepth_t             >  **  in_BRANCH_COMPLETE_DEPTH          ;
+  sc_signal<Taddress_t           >  **  in_BRANCH_COMPLETE_ADDRESS        ;
+  sc_signal<Tcontrol_t           >  **  in_BRANCH_COMPLETE_NO_SEQUENCE    ;
+  sc_signal<Tcontrol_t           >  ** out_BRANCH_COMPLETE_MISS_PREDICTION;
+  sc_signal<Tcontrol_t           >   *  in_COMMIT_EVENT_VAL               ;
+  sc_signal<Tcontrol_t           >   * out_COMMIT_EVENT_ACK               ;
+  sc_signal<Tcontext_t           >   *  in_COMMIT_EVENT_CONTEXT_ID        ;
+  sc_signal<Tdepth_t             >   *  in_COMMIT_EVENT_DEPTH             ;
+  sc_signal<Tevent_type_t        >   *  in_COMMIT_EVENT_TYPE              ;
+  sc_signal<Tcontrol_t           >   *  in_COMMIT_EVENT_IS_DELAY_SLOT     ;
+  sc_signal<Taddress_t           >   *  in_COMMIT_EVENT_ADDRESS           ;
+  sc_signal<Tcontrol_t           >   *  in_COMMIT_EVENT_ADDRESS_EPCR_VAL  ;
+  sc_signal<Taddress_t           >   *  in_COMMIT_EVENT_ADDRESS_EPCR      ;
+  sc_signal<Tcontrol_t           >   *  in_COMMIT_EVENT_ADDRESS_EEAR_VAL  ;
+  sc_signal<Tgeneral_data_t      >   *  in_COMMIT_EVENT_ADDRESS_EEAR      ;
+  sc_signal<Tcontrol_t           >  ** out_EVENT_VAL                      ;
+  sc_signal<Tcontrol_t           >  **  in_EVENT_ACK                      ;
+  sc_signal<Taddress_t           >  ** out_EVENT_ADDRESS                  ;
+  sc_signal<Taddress_t           >  ** out_EVENT_ADDRESS_NEXT             ;
+  sc_signal<Tcontrol_t           >  ** out_EVENT_ADDRESS_NEXT_VAL         ;
+  sc_signal<Tcontrol_t           >  ** out_EVENT_IS_DS_TAKE               ;
+  sc_signal<Tcontrol_t           >  ** out_SPR_EVENT_VAL                  ;
+  sc_signal<Tcontrol_t           >  **  in_SPR_EVENT_ACK                  ;
+  sc_signal<Tspr_t               >  ** out_SPR_EVENT_EPCR                 ;
+  sc_signal<Tcontrol_t           >  ** out_SPR_EVENT_EEAR_WEN             ;
+  sc_signal<Tspr_t               >  ** out_SPR_EVENT_EEAR                 ;
+  sc_signal<Tcontrol_t           >  ** out_SPR_EVENT_SR_DSX               ;
+  sc_signal<Tcontrol_t           >  ** out_SPR_EVENT_SR_TO_ESR            ;
+  sc_signal<Tcounter_t           >  **  in_NB_INST_COMMIT_ALL             ;
+  sc_signal<Tcounter_t           >  **  in_NB_INST_COMMIT_MEM             ;
+  sc_signal<Tcounter_t           >  ** out_NB_INST_DECOD_ALL              ;
+  sc_signal<Tdepth_t             >  ** out_DEPTH_MIN                      ;
+  sc_signal<Tdepth_t             >  ** out_DEPTH_MAX                      ;
+  sc_signal<Tcontrol_t           >  ** out_DEPTH_FULL                     ;
+  sc_signal<Tcontrol_t           >  **  in_SPR_SR_IEE                     ;
+  sc_signal<Tcontrol_t           >  **  in_SPR_SR_EPH                     ;
+  sc_signal<Tcontrol_t           >  **  in_INTERRUPT_ENABLE               ;
 
   ALLOC1_SC_SIGNAL(out_ICACHE_REQ_VAL                 ,"out_ICACHE_REQ_VAL                 ",Tcontrol_t           ,_param->_nb_context);
@@ -68,7 +145,5 @@
   ALLOC1_SC_SIGNAL(out_DECOD_NO_EXECUTE               ,"out_DECOD_NO_EXECUTE               ",Tcontrol_t           ,_param->_sum_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_IS_DELAY_SLOT            ,"out_DECOD_IS_DELAY_SLOT            ",Tcontrol_t           ,_param->_sum_inst_decod);
-#ifdef DEBUG
   ALLOC1_SC_SIGNAL(out_DECOD_ADDRESS                  ,"out_DECOD_ADDRESS                  ",Tgeneral_data_t      ,_param->_sum_inst_decod);
-#endif
   ALLOC1_SC_SIGNAL(out_DECOD_ADDRESS_NEXT             ,"out_DECOD_ADDRESS_NEXT             ",Tgeneral_data_t      ,_param->_sum_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_HAS_IMMEDIAT             ,"out_DECOD_HAS_IMMEDIAT             ",Tcontrol_t           ,_param->_sum_inst_decod);
@@ -325,7 +400,5 @@
   DELETE1_SC_SIGNAL(out_DECOD_NO_EXECUTE               ,_param->_sum_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_IS_DELAY_SLOT            ,_param->_sum_inst_decod);
-#ifdef DEBUG
   DELETE1_SC_SIGNAL(out_DECOD_ADDRESS                  ,_param->_sum_inst_decod);
-#endif
   DELETE1_SC_SIGNAL(out_DECOD_ADDRESS_NEXT             ,_param->_sum_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_HAS_IMMEDIAT             ,_param->_sum_inst_decod);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Front_end_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Front_end_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Front_end_deallocation.cpp	(revision 128)
@@ -109,7 +109,7 @@
         DELETE1_SIGNAL(out_NB_INST_DECOD_ALL                ,_param->_nb_context,_param->_size_nb_inst_decod);
 
-        DELETE1_SIGNAL(out_DEPTH_MIN                        ,_param->_nb_context,_param->_size_depth  );
-        DELETE1_SIGNAL(out_DEPTH_MAX                        ,_param->_nb_context,_param->_size_depth+1);
-        DELETE1_SIGNAL(out_DEPTH_FULL                       ,_param->_nb_context,_param->_size_depth+1);
+        DELETE1_SIGNAL(out_DEPTH_MIN                        ,_param->_nb_context,_param->_size_depth);
+        DELETE1_SIGNAL(out_DEPTH_MAX                        ,_param->_nb_context,_param->_size_depth);
+        DELETE1_SIGNAL(out_DEPTH_FULL                       ,_param->_nb_context,1);
 
         DELETE1_SIGNAL( in_SPR_SR_IEE                       ,_param->_nb_context,1);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/src/Parameters.cpp	(revision 128)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Core/Multi_Front_end/Front_end/include/Parameters.h"
+#include "Behavioural/include/Allocation.h"
 #include "Common/include/Max.h"
 
@@ -110,9 +111,9 @@
     uint32_t size_instruction_address   = size_general_data - 2;
 
-    _array_size_depth                   = new uint32_t [_nb_context];
+    ALLOC1(_array_size_depth            ,uint32_t,_nb_context);
     for (uint32_t i=0; i<_nb_context; i++)
       _array_size_depth [i] = log2(_upt_size_queue[i]);
     
-    _array_size_nb_inst_decod = new uint32_t [_nb_decod_unit];
+    ALLOC1(_array_size_nb_inst_decod    ,uint32_t,_nb_decod_unit);
     for (uint32_t i=0; i<_nb_decod_unit; i++)
       _array_size_nb_inst_decod [i] = log2(_size_decod_queue[i]+1);
@@ -159,15 +160,15 @@
        );
 
-    _translate_context_id_from_decod_unit= new std::vector<uint32_t> [_nb_decod_unit];
+    ALLOC1(_translate_context_id_from_decod_unit,std::vector<uint32_t>,_nb_decod_unit);
 
     for (uint32_t i=0; i<_nb_context; ++i)
       _translate_context_id_from_decod_unit [_link_context_to_decod_unit[i]].push_back(i);
 
-    _decod_unit_nb_context               = new uint32_t    [_nb_decod_unit];
-    _decod_unit_nb_inst_fetch            = new uint32_t *  [_nb_decod_unit];
-    _decod_unit_nb_branch_speculated     = new uint32_t *  [_nb_decod_unit];
-//     _decod_unit_depth                    = new uint32_t *  [_nb_decod_unit];
-    _decod_unit_instruction_implemeted   = new bool     ** [_nb_decod_unit];
-//     _have_port_decod_unit_context_id     = new bool        [_nb_decod_unit];
+    ALLOC1(_decod_unit_nb_context            ,uint32_t,_nb_decod_unit);
+    ALLOC2(_decod_unit_nb_inst_fetch         ,uint32_t,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+    ALLOC2(_decod_unit_nb_branch_speculated  ,uint32_t,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+//  ALLOC2(_decod_unit_depth                 ,uint32_t,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+    ALLOC3(_decod_unit_instruction_implemeted,bool    ,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size(),NB_INSTRUCTION);
+//  ALLOC2(_have_port_decod_unit_context_id  ,bool    ,_nb_decod_unit);
     _sum_inst_decod                      = 0;
     
@@ -179,9 +180,5 @@
 
         _decod_unit_nb_context             [i] = size;
-        _decod_unit_nb_inst_fetch          [i] = new uint32_t   [size];
-//         _decod_unit_depth                  [i] = new uint32_t   [size];
-        _decod_unit_nb_branch_speculated   [i] = new uint32_t   [size];
-        _decod_unit_instruction_implemeted [i] = new bool     * [size];
-//         _have_port_decod_unit_context_id   [i] = size > 0;
+//      _have_port_decod_unit_context_id   [i] = size > 0;
 
         for (uint32_t j=0; j<size; ++j)
@@ -191,6 +188,5 @@
             _decod_unit_nb_inst_fetch          [i][j] = _nb_inst_fetch  [x];
             _decod_unit_nb_branch_speculated   [i][j] = _upt_size_queue [x];
-//             _decod_unit_depth                  [i][j] = log2(_upt_size_queue[x]);
-            _decod_unit_instruction_implemeted [i][j] = new bool [NB_INSTRUCTION];
+//          _decod_unit_depth                  [i][j] = log2(_upt_size_queue[x]);
 
             for (uint32_t k=0; k<NB_INSTRUCTION; ++k)
@@ -302,25 +298,14 @@
     delete [] _param_ifetch_unit    ;
 
-//     delete [] _size_ifetch_queue_ptr;
-//     delete [] _size_nb_inst_decod;
-    delete [] _array_size_depth;
-    for (uint32_t i=0; i<_nb_context; ++i)
-      {
-        for (uint32_t j=0; j<_translate_context_id_from_decod_unit [i].size(); ++j)
-          delete [] _decod_unit_instruction_implemeted [i][j];
-
-        delete [] _decod_unit_nb_inst_fetch          [i];
-//         delete [] _decod_unit_depth                  [i];
-        delete [] _decod_unit_nb_branch_speculated   [i];
-        delete [] _decod_unit_instruction_implemeted [i];
-      }
-    delete [] _decod_unit_nb_inst_fetch         ;
-//     delete [] _decod_unit_depth                 ;
-    delete [] _decod_unit_nb_branch_speculated  ;
-    delete [] _decod_unit_instruction_implemeted;
-
-//     delete [] _have_port_decod_unit_context_id;
-    delete [] _decod_unit_nb_context               ;
-    delete [] _translate_context_id_from_decod_unit;
+//  DELETE2(_have_port_decod_unit_context_id     ,_nb_decod_unit);
+    DELETE3(_decod_unit_instruction_implemeted   ,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size(),NB_INSTRUCTION);
+//  DELETE2(_decod_unit_depth                    ,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+    DELETE2(_decod_unit_nb_branch_speculated     ,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+    DELETE2(_decod_unit_nb_inst_fetch            ,_nb_decod_unit,_translate_context_id_from_decod_unit [it1].size());
+    DELETE1(_decod_unit_nb_context               ,_nb_decod_unit);
+
+    DELETE1(_translate_context_id_from_decod_unit,_nb_decod_unit);
+    DELETE1(_array_size_nb_inst_decod            ,_nb_decod_unit);
+    DELETE1(_array_size_depth                    ,_nb_context);
 
     log_end(Front_end,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/main.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/main.cpp	(revision 128)
@@ -142,4 +142,6 @@
       
       test (name,param);
+
+      delete param;
     }
   catch (morpheo::ErrorMorpheo & error)
